#
# spec file for package ghc-monadloc
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name monadloc
Name:           ghc-%{pkg_name}
Version:        0.7.1
Release:        bp155.2.13
Summary:        A class for monads which can keep a monadic call trace
License:        SUSE-Public-Domain
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-transformers-devel

%description
This package defines a class for monads which can keep a monadic call trace.

* See the blog post
<http://pepeiborra.wordpress.com/2009/11/01/monadic-stack-traces-that-make-a-lot-of-sense>
for more information.

A preprocessor is available (see the package monadloc-pp) which inserts calls
to "Control.Monad.Loc.withLoc" before every monadic statement in a module.
To invoke the preprocessor, add the pragma 'OPTIONS_GHC -F -pgmF MonadLoc' at
the top of your Haskell files together with an import for the
"Control.Monad.Loc" module

This package provides no implementation of the "Control.Monad.Loc.MonadLoc"
interface. Currently the only package that does so is
'control-monad-exception', but any other package can implement it and provide
monadic call traces. /Changes/:

* 0.7 - Extracted Template Haskell macro to separate module to allow
'Control.Monad.Loc' to be Safe. (thanks to Deian Stefan)

* 0.6 - Extracted the preprocessor to a separate package 'monadloc-pp' to
minimize the set of dependencies.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files

%files devel -f %{name}-devel.files

%changelog
* Thu Aug  3 2017 psimons@suse.com
- Updated with latest spec-cleaner version 0.9.8-8-geadfbbf.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.7.1 revision 0 with cabal2obs.
